#!/bin/sh
#
# 2011 Nico Schottelius (nico-cdist at schottelius.org)
#
# This file is part of cdist.
#
# cdist is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# cdist is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with cdist. If not, see <http://www.gnu.org/licenses/>.
#
#
# __file is a very basic type and should be able to be used as an
# example for typewrites later
#

# If destination was specified, do not use the id
if [ -f "$__object/parameter/destination" ]; then
   destination="$(cat "$__object/parameter/destination")"
else
   # If no destination has been supplied, the id is the destination
   # Prepend /, which got lost in the object id (and relative paths
   # don't make sense)
   destination="/$__object_id"
fi

# Ensure we have an absolute path
if ! $(echo "$destination" | grep -q ^/); then
   echo "Error: Destination ($destination) of $__object_id is not absolute." >&2
   exit 1
fi

# Use correct md5sum binary - MacOSx is different here
case "$os" in
   macosx)
      md5sum="md5"
   ;;  

   *)  
      md5sum="md5sum"
   ;;  
esac

type="$(cat "$__object/parameter/type")"

case "$type" in
   directory)
      if [ -f "$__object/parameter/source" ]; then
         echo "Source not supported for directory currently - FIXME" >&2
         exit 1
      else
         if [ no = "$(cat "$__object/explorer/exists")" ]; then
            echo mkdir \"$destination\"
         fi
      fi
   ;;

   file)
      if [ -f "$__object/parameter/source" ]; then
         source="$(cat "$__object/parameter/source")"

         if [ -f "$source" ]; then
            local_md5sum="$($md5sum < "$source")"
            remote_md5sum="$(cat "$__object/explorer/md5sum")"

            # FIXME: Is md5sum the right approach?
            if [ "$local_md5sum" != "$remote_md5sum" ]; then
               # FIXME: This is ugly and hardcoded, replace after 1.0!
               # Probably a better aproach is to have the user configured
               # ~/.ssh/config to contain the right username
               # Probably describe it in cdist-quickstart...
               scp "$source" "root@${__target_host}:${destination}"
            fi
         else
            echo "Source \"$source\" does not exist." >&2
            exit 1
         fi
      else
         if [ no = "$(cat "$__object/explorer/exists")" ]; then
            echo touch \"$destination\"
         fi
      fi
   ;;

   symlink)
      if [ ! -f "$__object/parameter/source" ]; then
         echo "Source required for symlink" >&2
         exit 1
      fi
      source="$(cat "$__object/parameter/source")"

      # FIXME: handle directories or document & ignore?
      echo ln -sf \"$source\" \"$destination\"
   ;;

   *)
      echo "Unsupported type: \"$type\"" >&2
      exit 1
   ;;
esac

# Mode settings
if [ -f "$__object/parameter/mode" ]; then
   echo chmod \"$(cat "$__object/parameter/mode")\" \"$destination\"
fi

# Group
if [ -f "$__object/parameter/group" ]; then
   echo chgrp \"$(cat "$__object/parameter/group")\" \"$destination\"
fi

# Owner
if [ -f "$__object/parameter/owner" ]; then
   echo chown \"$(cat "$__object/parameter/owner")\" \"$destination\"
fi
